
<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.19: https://docutils.sourceforge.io/" />

    <title>FUSE API Functions &#8212; pyfuse3 3.4.0 documentation</title>
    <link rel="stylesheet" type="text/css" href="_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="_static/classic.css" />
    
    <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
    <script src="_static/jquery.js"></script>
    <script src="_static/underscore.js"></script>
    <script src="_static/_sphinx_javascript_frameworks_compat.js"></script>
    <script src="_static/doctools.js"></script>
    <script src="_static/sphinx_highlight.js"></script>
    
    <link rel="author" title="About these documents" href="about.html" />
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Data Structures" href="data.html" />
    <link rel="prev" title="asyncio Support" href="asyncio.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="data.html" title="Data Structures"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="asyncio.html" title="asyncio Support"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">pyfuse3 3.4.0 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">FUSE API Functions</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="fuse-api-functions">
<h1>FUSE API Functions<a class="headerlink" href="#fuse-api-functions" title="Permalink to this heading">¶</a></h1>
<dl class="py function">
<dt class="sig sig-object py" id="pyfuse3.init">
<span class="sig-prename descclassname"><span class="pre">pyfuse3.</span></span><span class="sig-name descname"><span class="pre">init</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">ops</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">mountpoint</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">options</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">default_options</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyfuse3.init" title="Permalink to this definition">¶</a></dt>
<dd><p>Initialize and mount FUSE file system</p>
<p><em>ops</em> has to be an instance of the <a class="reference internal" href="operations.html#pyfuse3.Operations" title="pyfuse3.Operations"><code class="xref py py-obj docutils literal notranslate"><span class="pre">Operations</span></code></a> class (or another
class defining the same methods).</p>
<p><em>args</em> has to be a set of strings. <a class="reference internal" href="data.html#pyfuse3.default_options" title="pyfuse3.default_options"><code class="xref py py-obj docutils literal notranslate"><span class="pre">default_options</span></code></a> provides some
reasonable defaults. It is recommended to use these options as a basis and
add or remove options as necessary. For example:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="n">my_opts</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="n">pyfuse3</span><span class="o">.</span><span class="n">default_options</span><span class="p">)</span>
<span class="n">my_opts</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="s1">&#39;allow_other&#39;</span><span class="p">)</span>
<span class="n">my_opts</span><span class="o">.</span><span class="n">discard</span><span class="p">(</span><span class="s1">&#39;default_permissions&#39;</span><span class="p">)</span>
<span class="n">pyfuse3</span><span class="o">.</span><span class="n">init</span><span class="p">(</span><span class="n">ops</span><span class="p">,</span> <span class="n">mountpoint</span><span class="p">,</span> <span class="n">my_opts</span><span class="p">)</span>
</pre></div>
</div>
<p>Valid options are listed under <code class="docutils literal notranslate"><span class="pre">struct</span>
<span class="pre">fuse_opt</span> <span class="pre">fuse_mount_opts[]</span></code>
(in <a class="reference external" href="https://github.com/libfuse/libfuse/blob/fuse-3.2.6/lib/mount.c#L80">mount.c</a>)
and <code class="docutils literal notranslate"><span class="pre">struct</span> <span class="pre">fuse_opt</span> <span class="pre">fuse_ll_opts[]</span></code>
(in <a class="reference external" href="https://github.com/libfuse/libfuse/blob/fuse-3.2.6/lib/fuse_lowlevel.c#L2572">fuse_lowlevel_c</a>).</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="pyfuse3.main">
<em class="property"><span class="k"><span class="pre">async</span></span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">pyfuse3.</span></span><span class="sig-name descname"><span class="pre">main</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">min_tasks</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">max_tasks</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">99</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyfuse3.main" title="Permalink to this definition">¶</a></dt>
<dd><p>Run FUSE main loop</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="pyfuse3.terminate">
<span class="sig-prename descclassname"><span class="pre">pyfuse3.</span></span><span class="sig-name descname"><span class="pre">terminate</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#pyfuse3.terminate" title="Permalink to this definition">¶</a></dt>
<dd><p>Terminate FUSE main loop.</p>
<p>This function gracefully terminates the FUSE main loop (resulting in the call to
main() to return).</p>
<p>When called by a thread different from the one that runs the main loop, the call must
be wrapped with <a class="reference external" href="https://trio.readthedocs.io/en/stable/reference-core.html#trio.from_thread.run_sync" title="(in Trio v0.26.2)"><code class="xref py py-obj docutils literal notranslate"><span class="pre">trio.from_thread.run_sync</span></code></a>. The necessary <em>trio_token</em> argument can
(for convience) be retrieved from the <a class="reference internal" href="#pyfuse3.trio_token" title="pyfuse3.trio_token"><code class="xref py py-obj docutils literal notranslate"><span class="pre">trio_token</span></code></a> module attribute.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="pyfuse3.close">
<span class="sig-prename descclassname"><span class="pre">pyfuse3.</span></span><span class="sig-name descname"><span class="pre">close</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">unmount</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyfuse3.close" title="Permalink to this definition">¶</a></dt>
<dd><p>Clean up and ensure filesystem is unmounted</p>
<p>If <em>unmount</em> is False, only clean up operations are peformed, but the file
system is not explicitly unmounted.</p>
<p>Normally, the filesystem is unmounted by the user calling umount(8) or
fusermount(1), which then terminates the FUSE main loop. However, the loop
may also terminate as a result of an exception or a signal. In this case the
filesystem remains mounted, but any attempt to access it will block (while
the filesystem process is still running) or (after the filesystem process
has terminated) return an error. If <em>unmount</em> is True, this function will
ensure that the filesystem is properly unmounted.</p>
<p>Note: if the connection to the kernel is terminated via the
<code class="docutils literal notranslate"><span class="pre">/sys/fs/fuse/connections/</span></code> interface, this function will <em>not</em> unmount
the filesystem even if <em>unmount</em> is True.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="pyfuse3.invalidate_inode">
<span class="sig-prename descclassname"><span class="pre">pyfuse3.</span></span><span class="sig-name descname"><span class="pre">invalidate_inode</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">fuse_ino_t</span> <span class="pre">inode</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">attr_only=False</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyfuse3.invalidate_inode" title="Permalink to this definition">¶</a></dt>
<dd><p>Invalidate cache for <em>inode</em></p>
<p>Instructs the FUSE kernel module to forget cached attributes and
data (unless <em>attr_only</em> is True) for <em>inode</em>.</p>
<p><strong>This operation may block</strong> if writeback caching is active and there is
dirty data for the inode that is to be invalidated. Unfortunately there is
no way to return control to the event loop until writeback is complete
(leading to a deadlock if the necessary write() requests cannot be processed
by the filesystem). Unless writeback caching is disabled, this function
should therefore be called from a separate thread.</p>
<p>If the operation is not supported by the kernel, raises <a class="reference external" href="https://docs.python.org/3/library/exceptions.html#OSError" title="(in Python v3.12)"><code class="xref py py-obj docutils literal notranslate"><span class="pre">OSError</span></code></a>
with errno ENOSYS.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="pyfuse3.invalidate_entry">
<span class="sig-prename descclassname"><span class="pre">pyfuse3.</span></span><span class="sig-name descname"><span class="pre">invalidate_entry</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">fuse_ino_t</span> <span class="pre">inode_p</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">name</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">fuse_ino_t</span> <span class="pre">deleted=0</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyfuse3.invalidate_entry" title="Permalink to this definition">¶</a></dt>
<dd><p>Invalidate directory entry</p>
<p>Instructs the FUSE kernel module to forget about the directory entry <em>name</em>
in the directory with inode <em>inode_p</em>.</p>
<p>If the inode passed as <em>deleted</em> matches the inode that is currently
associated with <em>name</em> by the kernel, any inotify watchers of this inode are
informed that the entry has been deleted.</p>
<p>If there is a pending filesystem operation that is related to the parent
directory or directory entry, this function will block until that operation
has completed. Therefore, to avoid a deadlock this function must not be
called while handling a related request, nor while holding a lock that could
be needed for handling such a request.</p>
<p>As for kernel 4.18, a “related operation” is a <a class="reference internal" href="operations.html#pyfuse3.Operations.lookup" title="pyfuse3.Operations.lookup"><code class="xref py py-obj docutils literal notranslate"><span class="pre">lookup</span></code></a>,
<a class="reference internal" href="operations.html#pyfuse3.Operations.symlink" title="pyfuse3.Operations.symlink"><code class="xref py py-obj docutils literal notranslate"><span class="pre">symlink</span></code></a>, <a class="reference internal" href="operations.html#pyfuse3.Operations.mknod" title="pyfuse3.Operations.mknod"><code class="xref py py-obj docutils literal notranslate"><span class="pre">mknod</span></code></a>, <a class="reference internal" href="operations.html#pyfuse3.Operations.mkdir" title="pyfuse3.Operations.mkdir"><code class="xref py py-obj docutils literal notranslate"><span class="pre">mkdir</span></code></a>,
<a class="reference internal" href="operations.html#pyfuse3.Operations.unlink" title="pyfuse3.Operations.unlink"><code class="xref py py-obj docutils literal notranslate"><span class="pre">unlink</span></code></a>, <a class="reference internal" href="operations.html#pyfuse3.Operations.rename" title="pyfuse3.Operations.rename"><code class="xref py py-obj docutils literal notranslate"><span class="pre">rename</span></code></a>, <a class="reference internal" href="operations.html#pyfuse3.Operations.link" title="pyfuse3.Operations.link"><code class="xref py py-obj docutils literal notranslate"><span class="pre">link</span></code></a> or
<a class="reference internal" href="operations.html#pyfuse3.Operations.create" title="pyfuse3.Operations.create"><code class="xref py py-obj docutils literal notranslate"><span class="pre">create</span></code></a> request for the parent, and a <a class="reference internal" href="operations.html#pyfuse3.Operations.setattr" title="pyfuse3.Operations.setattr"><code class="xref py py-obj docutils literal notranslate"><span class="pre">setattr</span></code></a>,
<a class="reference internal" href="operations.html#pyfuse3.Operations.unlink" title="pyfuse3.Operations.unlink"><code class="xref py py-obj docutils literal notranslate"><span class="pre">unlink</span></code></a>, <a class="reference internal" href="operations.html#pyfuse3.Operations.rmdir" title="pyfuse3.Operations.rmdir"><code class="xref py py-obj docutils literal notranslate"><span class="pre">rmdir</span></code></a>, <a class="reference internal" href="operations.html#pyfuse3.Operations.rename" title="pyfuse3.Operations.rename"><code class="xref py py-obj docutils literal notranslate"><span class="pre">rename</span></code></a>,
<a class="reference internal" href="operations.html#pyfuse3.Operations.setxattr" title="pyfuse3.Operations.setxattr"><code class="xref py py-obj docutils literal notranslate"><span class="pre">setxattr</span></code></a>, <a class="reference internal" href="operations.html#pyfuse3.Operations.removexattr" title="pyfuse3.Operations.removexattr"><code class="xref py py-obj docutils literal notranslate"><span class="pre">removexattr</span></code></a> or <a class="reference internal" href="operations.html#pyfuse3.Operations.readdir" title="pyfuse3.Operations.readdir"><code class="xref py py-obj docutils literal notranslate"><span class="pre">readdir</span></code></a>
request for the inode itself.</p>
<p>For technical reasons, this function can also not return control to the main
event loop but will actually block. To return control to the event loop
while this function is running, call it in a separate thread using
<a class="reference external" href="https://trio.readthedocs.io/en/latest/reference-core.html#trio.run_sync_in_worker_thread">trio.run_sync_in_worker_thread</a>.
A less complicated alternative is to use the <a class="reference internal" href="#pyfuse3.invalidate_entry_async" title="pyfuse3.invalidate_entry_async"><code class="xref py py-obj docutils literal notranslate"><span class="pre">invalidate_entry_async</span></code></a> function
instead.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="pyfuse3.invalidate_entry_async">
<span class="sig-prename descclassname"><span class="pre">pyfuse3.</span></span><span class="sig-name descname"><span class="pre">invalidate_entry_async</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">inode_p</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">name</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">deleted</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">ignore_enoent</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyfuse3.invalidate_entry_async" title="Permalink to this definition">¶</a></dt>
<dd><p>Asynchronously invalidate directory entry</p>
<p>This function performs the same operation as <a class="reference internal" href="#pyfuse3.invalidate_entry" title="pyfuse3.invalidate_entry"><code class="xref py py-obj docutils literal notranslate"><span class="pre">invalidate_entry</span></code></a>, but does so
asynchronously in a separate thread. This avoids the deadlocks that may
occur when using <a class="reference internal" href="#pyfuse3.invalidate_entry" title="pyfuse3.invalidate_entry"><code class="xref py py-obj docutils literal notranslate"><span class="pre">invalidate_entry</span></code></a> from within a request handler, but means
that the function generally returns before the kernel has actually
invalidated the entry, and that no errors can be reported (they will be
logged though).</p>
<p>The directory entries that are to be invalidated are put in an unbounded
queue which is processed by a single thread. This means that if the entry at
the beginning of the queue cannot be invalidated yet because a related file
system operation is still in progress, none of the other entries will be
processed and repeated calls to this function will result in continued
growth of the queue.</p>
<p>If there are errors, an exception is logged using the <a class="reference external" href="https://docs.python.org/3/library/logging.html#module-logging" title="(in Python v3.12)"><code class="xref py py-obj docutils literal notranslate"><span class="pre">logging</span></code></a> module.</p>
<p>If <em>ignore_enoent</em> is True, ignore ENOENT errors (which occur if the
kernel doesn’t actually have knowledge of the entry that is to be
removed).</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="pyfuse3.notify_store">
<span class="sig-prename descclassname"><span class="pre">pyfuse3.</span></span><span class="sig-name descname"><span class="pre">notify_store</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">inode</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">offset</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">data</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyfuse3.notify_store" title="Permalink to this definition">¶</a></dt>
<dd><p>Store data in kernel page cache</p>
<p>Sends <em>data</em> for the kernel to store it in the page cache for <em>inode</em> at
<em>offset</em>. If this provides data beyond the current file size, the file is
automatically extended.</p>
<p>If this function raises an exception, the store may still have completed
partially.</p>
<p>If the operation is not supported by the kernel, raises <a class="reference external" href="https://docs.python.org/3/library/exceptions.html#OSError" title="(in Python v3.12)"><code class="xref py py-obj docutils literal notranslate"><span class="pre">OSError</span></code></a>
with errno ENOSYS.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="pyfuse3.readdir_reply">
<span class="sig-prename descclassname"><span class="pre">pyfuse3.</span></span><span class="sig-name descname"><span class="pre">readdir_reply</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">ReaddirToken</span> <span class="pre">token</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">name</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">EntryAttributes</span> <span class="pre">attr</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">off_t</span> <span class="pre">next_id</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyfuse3.readdir_reply" title="Permalink to this definition">¶</a></dt>
<dd><p>Report a directory entry in response to a <a class="reference internal" href="operations.html#pyfuse3.Operations.readdir" title="pyfuse3.Operations.readdir"><code class="xref py py-obj docutils literal notranslate"><span class="pre">readdir</span></code></a> request.</p>
<p>This function should be called by the <a class="reference internal" href="operations.html#pyfuse3.Operations.readdir" title="pyfuse3.Operations.readdir"><code class="xref py py-obj docutils literal notranslate"><span class="pre">readdir</span></code></a> handler to
provide the list of directory entries. The function should be called
once for each directory entry, until it returns False.</p>
<p><em>token</em> must be the token received by the <a class="reference internal" href="operations.html#pyfuse3.Operations.readdir" title="pyfuse3.Operations.readdir"><code class="xref py py-obj docutils literal notranslate"><span class="pre">readdir</span></code></a> handler.</p>
<dl class="simple">
<dt><em>name</em> and must be the name of the directory entry and <em>attr</em> an</dt><dd><p><a class="reference internal" href="data.html#pyfuse3.EntryAttributes" title="pyfuse3.EntryAttributes"><code class="xref py py-obj docutils literal notranslate"><span class="pre">EntryAttributes</span></code></a> instance holding its attributes.</p>
</dd>
</dl>
<p><em>next_id</em> must be a 64-bit integer value that uniquely identifies the
current position in the list of directory entries. It may be passed back
to a later <a class="reference internal" href="operations.html#pyfuse3.Operations.readdir" title="pyfuse3.Operations.readdir"><code class="xref py py-obj docutils literal notranslate"><span class="pre">readdir</span></code></a> call to start another listing at the
right position. This value should be robust in the presence of file
removals and creations, i.e. if files are created or removed after a
call to <a class="reference internal" href="operations.html#pyfuse3.Operations.readdir" title="pyfuse3.Operations.readdir"><code class="xref py py-obj docutils literal notranslate"><span class="pre">readdir</span></code></a> and <a class="reference internal" href="operations.html#pyfuse3.Operations.readdir" title="pyfuse3.Operations.readdir"><code class="xref py py-obj docutils literal notranslate"><span class="pre">readdir</span></code></a> is called again
with <em>start_id</em> set to any previously supplied <em>next_id</em> values, under
no circumstances must any file be reported twice or skipped over.</p>
</dd></dl>

<dl class="py data">
<dt class="sig sig-object py" id="pyfuse3.trio_token">
<span class="sig-prename descclassname"><span class="pre">pyfuse3.</span></span><span class="sig-name descname"><span class="pre">trio_token</span></span><a class="headerlink" href="#pyfuse3.trio_token" title="Permalink to this definition">¶</a></dt>
<dd><p>Set to the value returned by <a class="reference external" href="https://trio.readthedocs.io/en/stable/reference-lowlevel.html#trio.lowlevel.current_trio_token" title="(in Trio v0.26.2)"><code class="xref py py-obj docutils literal notranslate"><span class="pre">trio.lowlevel.current_trio_token</span></code></a> while <a class="reference internal" href="#pyfuse3.main" title="pyfuse3.main"><code class="xref py py-obj docutils literal notranslate"><span class="pre">main</span></code></a> is
running. Can be used by other threads to run code in the main loop through
<a class="reference external" href="https://trio.readthedocs.io/en/stable/reference-core.html#trio.from_thread.run" title="(in Trio v0.26.2)"><code class="xref py py-obj docutils literal notranslate"><span class="pre">trio.from_thread.run</span></code></a>.</p>
</dd></dl>

</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper"><h3><a href="index.html">Table Of Contents</a></h3>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="about.html">About</a></li>
<li class="toctree-l1"><a class="reference internal" href="install.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="general.html">General Information</a></li>
<li class="toctree-l1"><a class="reference internal" href="asyncio.html">asyncio Support</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">FUSE API Functions</a></li>
<li class="toctree-l1"><a class="reference internal" href="data.html">Data Structures</a></li>
<li class="toctree-l1"><a class="reference internal" href="operations.html">Request Handlers</a></li>
<li class="toctree-l1"><a class="reference internal" href="util.html">Utility Functions</a></li>
<li class="toctree-l1"><a class="reference internal" href="gotchas.html">Common Gotchas</a></li>
<li class="toctree-l1"><a class="reference internal" href="example.html">Example File Systems</a></li>
<li class="toctree-l1"><a class="reference internal" href="changes.html">Changelog</a></li>
</ul>

  <div>
    <h4>Previous topic</h4>
    <p class="topless"><a href="asyncio.html"
                          title="previous chapter">asyncio Support</a></p>
  </div>
  <div>
    <h4>Next topic</h4>
    <p class="topless"><a href="data.html"
                          title="next chapter">Data Structures</a></p>
  </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="data.html" title="Data Structures"
             >next</a> |</li>
        <li class="right" >
          <a href="asyncio.html" title="asyncio Support"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">pyfuse3 3.4.0 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">FUSE API Functions</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010-2024, Nikolaus Rath.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 5.3.0.
    </div>
  </body>
</html>